diff --git a/src/fns.c b/src/fns.c
index f5f222c39c..292d6fc405 100644
--- a/src/fns.c
+++ b/src/fns.c
@@ -514,7 +514,23 @@ DEFUN ("string-lessp", Fstring_lessp, Sstring_lessp, 2, 2, 0,
   else
     {
       /* string1 unibyte, string2 multibyte */
-      ptrdiff_t i1 = 0, i2 = 0, i2_byte = 0;
+
+      ptrdiff_t nb1 = n;
+      ptrdiff_t nb2 = SBYTES (string2);
+      ptrdiff_t nb = min (nb1, nb2);
+
+      /* Skip identical ASCII-only prefixes, a word at a time.  */
+      typedef size_t word_t;
+      int ws = sizeof (word_t);
+      word_t msbits = (word_t)0x8080808080808080;
+      const word_t *w1 = (const word_t *) SDATA (string1);
+      const word_t *w2 = (const word_t *) SDATA (string2);
+      ptrdiff_t b = 0;
+      while (b < nb - ws + 1 && w1[b / ws] == w2[b / ws]
+	     && !(w1[b / ws] & msbits))
+	b += ws;
+
+      ptrdiff_t i1 = b, i2 = b, i2_byte = b;
       while (i1 < n)
 	{
 	  int c1 = SREF (string1, i1++);
